#ifndef __net_soioctl__
#define __net_soioctl__
/*
 * Copyright (c) 1982 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 *
 *	@(#)ioctl.h	6.14 (Berkeley) 8/25/85
 */

/*
 * Ioctl definitions
 */
#ifdef sgi
#include <sys/ioctl.h>
#endif

/* socket i/o controls */
#define	SIOCSHIWAT	_IOW('s',  0, int)		/* set high watermark */
#define	SIOCGHIWAT	_IOR('s',  1, int)		/* get high watermark */
#define	SIOCSLOWAT	_IOW('s',  2, int)		/* set low watermark */
#define	SIOCGLOWAT	_IOR('s',  3, int)		/* get low watermark */
#define	SIOCATMARK	_IOR('s',  7, int)		/* at oob mark? */
#define	SIOCSPGRP	_IOW('s',  8, int)		/* set process group */
#define	SIOCGPGRP	_IOR('s',  9, int)		/* get process group */
#ifdef sgi
/* 
 * Like FIONREAD except if the socket can't receive more data or the transport
 * layer detected an error, ioctl returns -1 & sets errno to one of
 *	stream socket: ECONNRESET, ETIMEDOUT 
 *	dgram socket:  ECONNRESET, EHOSTUNREACH, ECONNREFUSED (if connected)
 */
#define SIOCNREAD	_IOR('s', 10, int)		/* get #bytes to read */
#endif

#define	SIOCADDRT	_IOW('r', 10, struct rtentry)	/* add route */
#define	SIOCDELRT	_IOW('r', 11, struct rtentry)	/* delete route */
#ifdef sgi
/* 
 * Do not use these unsupported, temporary ioctls -- they will disappear
 * in the next IRIX release.
 */
#define	SIOCSETRTINFO	_IOWR('r', 12, struct fullrtentry) /* change info */
#define	SIOCGETRTINFO	_IOWR('r', 13, struct fullrtentry) /* get info */
#endif

#define	SIOCSIFADDR	_IOW('i', 12, struct ifreq)	/* set ifnet address */
#define	SIOCGIFADDR	_IOWR('i',13, struct ifreq)	/* get ifnet address */
#define	SIOCSIFDSTADDR	_IOW('i', 14, struct ifreq)	/* set p-p address */
#define	SIOCGIFDSTADDR	_IOWR('i',15, struct ifreq)	/* get p-p address */
#define	SIOCSIFFLAGS	_IOW('i', 16, struct ifreq)	/* set ifnet flags */
#define	SIOCGIFFLAGS	_IOWR('i',17, struct ifreq)	/* get ifnet flags */
#define	SIOCGIFBRDADDR	_IOWR('i',18, struct ifreq)	/* get broadcast addr */
#define	SIOCSIFBRDADDR	_IOW('i',19, struct ifreq)	/* set broadcast addr */
#define	SIOCGIFCONF	_IOWR('i',20, struct ifconf)	/* get ifnet list */
#define	SIOCGIFNETMASK	_IOWR('i',21, struct ifreq)	/* get net addr mask */
#define	SIOCSIFNETMASK	_IOW('i',22, struct ifreq)	/* set net addr mask */
#define	SIOCGIFMETRIC	_IOWR('i',23, struct ifreq)	/* get IF metric */
#define	SIOCSIFMETRIC	_IOW('i',24, struct ifreq)	/* set IF metric */

#define	SIOCSARP	_IOW('i', 30, struct arpreq)	/* set arp entry */
#define	SIOCGARP	_IOWR('i',31, struct arpreq)	/* get arp entry */
#define	SIOCDARP	_IOW('i', 32, struct arpreq)	/* delete arp entry */

#ifdef sgi
#define	SIOCADDMULTI	_IOW('i', 33, struct ifreq)	/* add multicast addr */
#define	SIOCDELMULTI	_IOW('i', 34, struct ifreq)	/* delete multicast */
#define	SIOCSIFSTATS	_IOW('i', 35, struct ifreq)	/* set ifnet stats */
#define	SIOCGIFSTATS	_IOWR('i', 36, struct ifreq)	/* get ifnet stats */
#define SIOCSIFHEAD	_IOW('i', 37, struct ifreq)	/* put specified IF at
							   head of list */
#endif

#endif	/* __net_soioctl__ */
