#ifndef __PWD_H__
#define __PWD_H__
#ifdef __cplusplus
extern "C" {
#endif
/* Copyright (C) 1989 Silicon Graphics, Inc. All rights reserved.  */
/* ------------------------------------------------------------------ */
/* | Copyright Unpublished, MIPS Computer Systems, Inc.  All Rights | */
/* | Reserved.  This software contains proprietary and confidential | */
/* | information of MIPS and its suppliers.  Use, disclosure or     | */
/* | reproduction is prohibited without the prior express written   | */
/* | consent of MIPS.                                               | */
/* ------------------------------------------------------------------ */
/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident "$Revision: 1.16 $"

#include <sys/types.h>

struct passwd {
	char	*pw_name;
	char	*pw_passwd;
	ushort	pw_upad;	/* pads added to allow POSIX compliancy for */
	uid_t	pw_uid;		/* uid_t and gid_t types. */
	ushort	pw_gpad;
	gid_t	pw_gid;
	char	*pw_age;
	char	*pw_comment;
	char	*pw_gecos;
	char	*pw_dir;
	char	*pw_shell;
	int	pw_origin;	 /* type of entry, defined below. */
	char	*pw_yp_passwd;	 /* if non-null, yp passwd value */
	char	*pw_yp_gecos;	 /* if non-null, yp gecos field */
	char	*pw_yp_dir;	 /* if non-null, yp home directory */
	char	*pw_yp_shell;	 /* if non-null, yp login shell */
	char	*pw_yp_netgroup; /* if non-null, yp netgroup name */
};

#if !defined(_POSIX_SOURCE)

/* pw_origin values: */
#define _PW_LOCAL	0
#define _PW_YP_USER	1
#define _PW_YP_NETGROUP	2
#define _PW_YP_ALL	3
#define	_PW_YP_REMOTE	4

struct comment {
	char	*c_dept;
	char	*c_name;
	char	*c_acct;
	char	*c_bin;
};
#endif 	/* !_POSIX_SOURCE */

extern struct passwd *	getpwuid(uid_t);
extern struct passwd *	getpwnam(const char *);
#if !defined(_POSIX_SOURCE)
struct __file_s;	/* define structure tag for ansi */
extern struct passwd *	getpwent(void);
extern void		setpwent(void);
extern void		endpwent(void);
extern struct passwd *	fgetpwent(struct __file_s *);
extern int		putpwent(const struct passwd *, struct __file_s *);
extern void		_yp_setpwent(void);
extern struct passwd *	_yp_getpwent(void);
extern struct passwd *	_pw_interpret(char *, int, struct __file_s *);
extern int		lckpwdf(void);
extern int		ulckpwdf(void);
#endif 	/* !_POSIX_SOURCE */

#ifdef __cplusplus
}
#endif
#endif /* !__PWD_H__ */
