#ifndef __STRING_H__
#define __STRING_H__
#ifdef __cplusplus
extern "C" {
#endif
/* Copyright (C) 1989 Silicon Graphics, Inc. All rights reserved.  */
/* ------------------------------------------------------------------ */
/* | Copyright Unpublished, MIPS Computer Systems, Inc.  All Rights | */
/* | Reserved.  This software contains proprietary and confidential | */
/* | information of MIPS and its suppliers.  Use, disclosure or     | */
/* | reproduction is prohibited without the prior express written   | */
/* | consent of MIPS.                                               | */
/* ------------------------------------------------------------------ */
/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

/* #ident "$Revision: 1.14 $" */

/* ANSI C Notes:
 *
 * - THE IDENTIFIERS APPEARING OUTSIDE OF #ifdef __EXTENSIONS__ IN THIS
 *   standard header ARE SPECIFIED BY ANSI!  CONFORMANCE WILL BE ALTERED
 *   IF ANY NEW IDENTIFIERS ARE ADDED TO THIS AREA UNLESS THEY ARE IN ANSI's
 *   RESERVED NAMESPACE. (i.e., unless they are prefixed by __[a-z] or
 *   _[A-Z].  For external objects, identifiers with the prefix _[a-z] 
 *   are also reserved.)
 *
 * - In addition, names beginning with 'str[a-z]', 'mem[a-z]', and
 *   'wcs[a-z]' are reserved when including <string.h>.
 */

#ifndef NULL
#define NULL	0
#endif

#ifndef _SIZE_T_
#define _SIZE_T_
typedef unsigned size_t;
#endif /* !_SIZE_T_ */

extern char *	strcpy(char *, const char *);
extern char *	strncpy(char *, const char *, size_t);
extern char *	strcat(char *, const char *);
extern char *	strncat(char *, const char *, size_t);
extern void *	memcpy(void *, const void *, size_t);
extern int	memcmp(const void *, const void *, size_t);
extern void *	memchr(const void *, int, size_t);
extern void *	memset(void *, int, size_t);
extern int	strcmp(const char *, const char *);
extern int	strncmp(const char *, const char *, size_t);
extern char *	strchr(const char *, int);
extern size_t	strcspn(const char *, const char *);
extern char *	strpbrk(const char *, const char *);
extern char *	strrchr(const char *, int);
extern size_t	strspn(const char *, const char *);
extern char *	strstr(const char *, const char *);
extern char *	strtok(char *, const char *);
extern size_t	strlen(const char *);
extern char *	strerror(int);

extern void *	memmove(void *, const void *, size_t);
extern int	strcoll(const char *, const char *);
extern size_t	strxfrm(char *, const char *, size_t);

/*
 * The following functions may legally appear in this header, although
 * they do not appear in the standard.
 */
extern char *	strdup(const char *);
extern void *	memccpy(void *, const void *, int, int);

/* Case-insensitive comparision routines from 4.3BSD.  */
extern int	strcasecmp(const char *, const char *);
extern int	strncasecmp(const char *, const char *, size_t);

#ifdef __cplusplus
}
#endif
#endif /* !__STRING_H__ */
