/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

#ident	"$Revision: 3.2 $"

/*
 * The callout structure is for a routine arranging
 * to be called by the clock interrupt
 * (clock.c) with a specified argument,
 * in a specified amount of time.
 * Used, for example, to time tab delays on typewriters.
 */
union c_tid {
	unsigned int c_eid;	/* entire identifier */
	struct {
		unsigned ci_cpuid : 5;	/* list entry is on */
		unsigned ci_cid : 27;	/* ID for removal */
	} c_pid; 
}; 
	

struct	callout {
	int	c_time;			/* incremental time */
	caddr_t	c_arg;			/* argument to routine */
	caddr_t	c_arg1;			/* argument to routine */
	caddr_t	c_arg2;			/* argument to routine */
	caddr_t	c_arg3;			/* argument to routine */
	int	(*c_func)();		/* routine */
	struct	callout *c_next;	/* link to next entry */
	union c_tid c_tid;
};

#define c_id 	c_tid.c_eid
#define c_cid 	c_tid.c_pid.ci_cid
#define c_cpuid c_tid.c_pid.ci_cpuid
