#ifndef __EFS_INODE_H__
#define	__EFS_INODE_H__
/*
 * The in-core efs inode structure.
 *
 * $Revision: 3.5 $
 */
#include "sys/fs/com_inode.h"
#include "sys/fs/efs_ino.h"

/*
 * Version of a regular, directory, or symbolic link extent inode as it appears
 * in memory.  This is a template for the actual data structure which contains
 * ii_numextents worth of ii_extents.
 */
struct efs_inode {
	struct	com_inode ii_com;	/* common stuff */
	short	ii_flags;		/* random flags */
	short	ii_numextents;		/* number of extents */
	short	ii_numindirs;		/* number of indirect extents */
	long	ii_indirbytes;		/* bytes in indir extents */
	extent	*ii_indir;		/* malloc'd indirect extent info */
	long	ii_dblks;		/* disk inode's high-water mark */
	extent	ii_extents[1];		/* actually, more of these */
};

#ifdef _KERNEL

/* efs inode flags */
#define	II_TRUNC	0x0001		/* inode may need truncation */
#define	II_INCORE	0x0002		/* indirect extents in core */

#define	EFS_IMAGIC	0x56374696
#define	efs_fsptr(ip)	((struct efs_inode *) (ip)->i_fsptr)

#endif	/* _KERNEL */
#endif	/* __EFS_INODE_H__ */
