#ifndef __SYS_KOPT_H__
#define __SYS_KOPT_H__

/**************************************************************************
 *									  *
 * 		 Copyright (C) 1990, Silicon Graphics, Inc.		  *
 *									  *
 *  These coded instructions, statements, and computer programs  contain  *
 *  unpublished  proprietary  information of Silicon Graphics, Inc., and  *
 *  are protected by Federal copyright law.  They  may  not be disclosed  *
 *  to  third  parties  or copied or duplicated in any form, in whole or  *
 *  in part, without the prior written consent of Silicon Graphics, Inc.  *
 *									  *
 **************************************************************************/
/*
 * Kernel options.
 * These kernel options are accesible by the user via the sgikopt() system
 * call.
 *
 */
#ident "$Revision: 3.23 $"

#ifdef	_KERNEL
#define TRUE_VALUE	"istrue"
#define FALSE_VALUE	"isfalse"

extern	int	is_true(/* char *string */);
extern	int	is_specified(/* char *string */);

extern char arg_root[];
extern char arg_swap[];
extern char arg_showconfig[];
extern char arg_initfile[];
extern char arg_initstate[];
extern char arg_swplo[];
extern char arg_nswap[];
extern char arg_console[];
extern char arg_gfx[];
extern char arg_keybd[];
extern char arg_monitor[];
extern char arg_sync_on_green[];
extern char arg_pagecolor[];		/* IP6/IP12/IP20/IP22 only */
extern char arg_screencolor[];		/* IP6/IP12 only */
extern char arg_logocolor[];		/* IP6/IP12 only */
extern char arg_netaddr[];
extern char arg_srvaddr[];
extern char arg_tapedevice[];
extern char arg_dlserver[];
extern char arg_maxpmem[];
#if defined(IP12) || defined(IP20) || defined(IP22)
extern char arg_eaddr[];
#endif
#if !(defined(IP20) || defined(IP22))	/* not ARCS PROM */
extern char arg_bootfile[];
extern char arg_bootmode[];
#else
extern char arg_diagmode[];
extern char arg_scsiretry[];
extern char arg_scsihostid[];
extern char arg_syspart[];
extern char arg_ospart[];
extern char arg_osloader[];
extern char arg_osfile[];
extern char arg_osopts[];
extern char arg_autoload[];
extern char arg_timezone[];
extern char arg_sgilogo[];
extern char arg_nogui[];
#endif

extern int showconfig;

/*
 * Kernel argument table. described in detail in master.d/kopt.
 */
struct	kernargs {
	char	*name;
	char	*str_ptr;		/* Pointer to local storage  */
	int	strlen;			/* Size of local storage */
	int	readonly;
};

extern struct kernargs kernargs[];
#endif /* _KERNEL */

#endif /* __SYS_KOPT_H__ */
