/**************************************************************************
 *									  *
 * 		 Copyright (C) 1987, Silicon Graphics, Inc.		  *
 *									  *
 *  These coded instructions, statements, and computer programs  contain  *
 *  unpublished  proprietary  information of Silicon Graphics, Inc., and  *
 *  are protected by Federal copyright law.  They  may  not be disclosed  *
 *  to  third  parties  or copied or duplicated in any form, in whole or  *
 *  in part, without the prior written consent of Silicon Graphics, Inc.  *
 *									  *
 **************************************************************************/

#ifndef __SYS_MMAN_H__
#define __SYS_MMAN_H__

#ifdef __cplusplus
extern "C" {
#endif

#ident	"$Revision: 3.11 $"

/*	mmap flags and protections
*/
#define	MAP_SHARED	0x1	/* share changes */
#define	MAP_PRIVATE	0x2	/* changes are private */
#define	MAP_TYPE	0xf	/* mask for mapping type */

#define	MAP_FIXED	0x10	/* interpret addr exactly */
#define MAP_RENAME	0x20	/* assign page to file */
#define MAP_AUTOGROW	0x40	/* file grows with store access */
#define	MAP_LOCAL	0x80	/* separate copies made on fork/sproc */

#define PROT_NONE	0x0	/* page can not be accessed */
#define PROT_EXECUTE	0x1	/* page can be executed */
#define PROT_WRITE	0x2	/* page can be written */
#define PROT_READ	0x4	/* page can be read */

/*	msync flags
*/
#define	MS_ASYNC	0x1	/* return immediately */
#define	MS_INVALIDATE	0x2	/* invalidate mappings */

/*	advice to madvise
*/
#define	MADV_NORMAL	0		/* no further special treatment */
#define	MADV_RANDOM	1		/* expect random page references */
#define	MADV_SEQUENTIAL	2		/* expect sequential page references */
#define	MADV_WILLNEED	3		/* will need these pages */
#define	MADV_DONTNEED	4		/* don't need these pages */

#ifndef _KERNEL
#include <sys/types.h>

extern void	*mmap(void *, int, int, int, int, off_t);
extern int	msync(void *, int, int);
extern int	munmap(void *, int);
extern int	madvise(void *, int, int);

#endif /* !_KERNEL */

#ifdef __cplusplus
}
#endif

#endif /* !__SYS_MMAN_H__ */
