#ident "$Revision: 1.2 $"

/***
COPYRIGHT 1984, 1985, 1986 by THE ORION GROUP, INC.
-----------------------------------------------------------------------
.WHAT:			@(#)ddsbds.h	100.2
.SCCS ID:		100.2
.TODAY'S DATE:		12/13/88
.CURRENT TIME:		20:40:11
.DATE OF THIS DELTA:	12/13/88
.TIME OF THIS DELTA:	20:39:49
-----------------------------------------------------------------------
OBJECT:		ddsbds.h

FULL NAME:	ddsbds.h

TYPE:		Device driver

FUNCTION:	Define kernel data structures containing information about
			the board.

INPUTS:		None

OUTPUTS:	None
-----------------------------------------------------------------------
***/

#ifndef DDSBDS
#define DDSBDS

struct board_data {
	hex *bi_scma;			/* starting address of board window */
	hex *bi_ecma;			/* ending address of board window */
	shex bi_ivn;			/* interrupt vector number*/
	hex b_vme_irq;			/* vme interrupt level */
	shex *b_vmecsr;			/* address of the board's control/status reg */
	shex bd_ready;			/* set when board data structures are in place */
	shex bd_initialized;
	shex ksleep_flag;
	shex bd_state;			/* values: UNDEF, DWNLDING, DIAGS, READY */
	};


/* CONSTANTS: */

#define LOAD			0x01		/* tell the board: download in progress */
#define SLEEPING		0xFF		/* download: waiting for int from board */
#define SLEEP_ERROR		0xFE		/* awakened by a timeout */

/* VME DECLARATIONS FROM MASTER FILE /usr/sysgen/master.d/si */

extern struct board_data board_d[];
extern int n_slot;

#endif
