#ifndef __SYS_SPLOCK_H__
#define __SYS_SPLOCK_H__

/**************************************************************************
 *									  *
 * 		 Copyright (C) 1990, Silicon Graphics, Inc.		  *
 *									  *
 *  These coded instructions, statements, and computer programs  contain  *
 *  unpublished  proprietary  information of Silicon Graphics, Inc., and  *
 *  are protected by Federal copyright law.  They  may  not be disclosed  *
 *  to  third  parties  or copied or duplicated in any form, in whole or  *
 *  in part, without the prior written consent of Silicon Graphics, Inc.  *
 *									  *
 **************************************************************************/

#ident "$Revision: 3.10 $"

#define	SPLOCKNAMSIZ	8

struct k_splockmeter {
	char	m_name[SPLOCKNAMSIZ];	/* text name for lock */
	short	m_inuse;		/* has been allocated */
	short	m_owner;		/* owner of lock */
	lock_t	m_addr;			/* lock address */
	ulong 	m_wait;			/* count of times locker had to wait */
	ulong 	m_lcnt;			/* count of 'lock' operations */
	ulong 	m_ucnt;			/* count of 'unlock' operations */
	uint	m_callpc;		/* return pc of last lock */
};

extern struct k_splockmeter k_splockmeter[];

extern int nsplock;			/* number of kernel spin locks */
extern int splocktype;			/* spin lock implementation */
extern int splockmeter;			/* if non-zero, do spin lock metering */

#define	SPLOCK_NONE	0		/* no spinlocks (SIMPLEX kernel) */
#define	SPLOCK_SOFT	1		/* software spinlocks */
#define	SPLOCK_HARD	2		/* hardware locks */

#define	OWNER_NONE	-1

#define	MAP_LOCKID	0		/* spinlock map index */
#define	SPLOCK_MAX	32768		/* number of available spinlocks */

#endif /* !__SYS_SPLOCK_H__ */
